/***************************************************************************
                          HttpGetCall.cpp  -  description
                             -------------------
    begin                : Mon Sep 30 2002
    copyright            : (C) 2002 by Henrik Baastrup
    email                : hba@libero.it
    home page            : http://digilander.iol.it/hba/Linux/index.html
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU LGPL (Lesser general Public License) 
 *   as published by the Free Software Foundation:
 *   http://www.gnu.org/copyleft/lesser.html or in the file copying.txt
 *
 ***************************************************************************/

#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include "HttpSession.h"


#ifdef WIN32
void uri2WindowsFile(char *uri)
{
	char *cp;

	if (uri==NULL) return;
	cp = uri;
	while (*cp) {
		switch (*cp) {
			case '/':
				*cp = '\\';
				break;
		}
		cp++;
	}
}//uri2Windows
#endif


void sendRequstedFile(HttpSession *session)
/*
 * This metod read a file and placed it in the response buffer
 */
{
	FILE *fd;
	char *uri, *homeDir, headerStr[256], bodyStr[2048], str[256] ;

	//Create the full file name path
	uri = session->getRequstURI();
#ifdef WIN32
	uri2WindowsFile(uri);
#endif
	homeDir = session->getHomeDir();
	sprintf(bodyStr,"%s%s",homeDir,uri);
	session->setContentType("text/html");

	//Open the file
	if ((fd=fopen(bodyStr, "r"))==NULL) {
		strcpy(headerStr, "404 Not Found");
		sprintf(bodyStr,"<HTML><HEAD></HEAD<BODY>\n<H1>Error 404</H1>\nThe requested file (%s) could not be found\n</BODY></HTML>\n",uri);
		session->writeError(headerStr, bodyStr);
		return;
	}

	//Read the file and plase its data in the response buffer
	*bodyStr = '\0';
	while (fgets(str, 255, fd)) {
		str[255] = '\0';
		strcat(bodyStr,str);
//		session->sendStr(bodyStr);
	}
	bodyStr[2047] = '\0';
	session->setContentLength(strlen(bodyStr));
	session->setContentType("text/html");
	session->writeOkHeader();
	session->sendStr(bodyStr);
	fclose(fd);
}//sendRequstedFile




void HttpGetCall(char *httpMsgBody, HttpSession *session)
/*
 * This is the function there is called when a HTTP POST method
 * is invorked. The httpMsgBody parameter point to the body of
 * the http message. The responseMsg is a pointer to a char
 * pointer where the call can allocate and respond with a message.
 */
{
	if (session==NULL) return;

	session->setContentType("text/html");
	sendRequstedFile(session);
}//HttpGetCall
