/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Fri May  4 15:39:13 CEST 2002
    copyright            : (C) 2002 by Henrik Baastrup
    email                : hba@libero.it
    home page            : http://digilander.iol.it/hba/Linux/index.html
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU LGPL (Lesser general Public License) 
 *   as published by the Free Software Foundation:
 *   http://www.gnu.org/copyleft/lesser.html
 *
 ***************************************************************************/

#ifdef LINUX

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream.h>
#include <stdlib.h>
#include <sys/stat.h>

#include "MiniHTTP.h"
#include "MiniHttpDefines.h";


extern int HttpPostCall(char *, char **, HttpSession *); //See HttpPostCall.cpp
extern void HttpGetCall(char *, HttpSession *); //See HttpGetCall.cpp

int main(int argc, char *argv[])
{
	short port = 6080;
	MiniHTTP  miniHttp;

	miniHttp.setPostFunctionCall(HttpPostCall);
	miniHttp.setGetFunctionCall(HttpGetCall);
	if ((argc > 1) && (strcmp(argv[2],"-d")==0)) { //Run in demon mode
		pid_t pid, sid;

		pid = fork();
		if (pid < 0) return EXIT_FAILURE;
		if (pid > 0) return EXIT_SUCCESS; //The parent, lets bail
		
		//The child process continue here!
		if((sid=setsid()) < 0) return EXIT_FAILURE; //Run child in a new session
		if (chdir("/") < 0)  return EXIT_FAILURE; //Make root (/) the current directory
		umask(0); //Reset the file mode
		// Close unneeded file discriptors
		close(STDIN_FILENO);
		close(STDOUT_FILENO);
		close(STDERR_FILENO);

		//Finaly lets work!
		miniHttp.runService(port);
	}
	else { // Run in application mode
		cout << "Start Server to listen on port: "<< port << endl;
		miniHttp.runService(port);
		if (miniHttp.getHaveError()) {
			printf("%s\n",miniHttp.getErrorString());
			return EXIT_FAILURE;
		}
	}

	return EXIT_SUCCESS;
}//LinuxMain

#endif
